#include <iostream>
using namespace std;

// PrintVisitor and DoVisitor show by using a different implementation the Car class is unchanged
// even though the algorithm is different in PrintVisitor and DoVisitor.

class CarElementPrintVisitor : public CarElementVisitor 
{
public:
    void visit(Wheel& wheel) const
    { 
        cout << "Visiting " << wheel.getName() << " wheel" << endl;
    }
    void visit(Engine& engine) const
    {
        cout << "Visiting engine" << endl;
    }
    void visit(Body& body) const
    {
        cout << "Visiting body" << endl;
    }
    void visitCar(Car& car) const
    {
        cout << endl << "Visiting car" << endl;
        vector<CarElement*>& elems = car.getElements();
        for(vector<CarElement*>::iterator it = elems.begin();
            it != elems.end(); ++it )
        {
            (*it)->accept(*this);	// this issues the callback i.e. to this from the element  
        }
        cout << "Visited car" << endl;
    }
};

