// From:
// http://en.wikipedia.org/wiki/Visitor_pattern

#include "CarElementVisitor.h"
#include "CarElement.h"
#include "Wheel.h"
#include "Engine.h"
#include "Body.h"
#include "Car.h"
#include "CarElementPrintVisitor.h"
#include "CarElementDoVisitor.h"

int main()
{
  Car car;
  CarElementPrintVisitor printVisitor;
  CarElementDoVisitor doVisitor;
 
  printVisitor.visitCar(car);
  doVisitor.visitCar(car);
 
  return 0;
}

/*Output:

Visiting car
Visiting front left wheel
Visiting front right wheel
Visiting back left wheel
Visiting back right wheel
Visiting body
Visiting engine
Visited car

Starting my car
Kicking my front left wheel
Kicking my front right wheel
Kicking my back left wheel
Kicking my back right wheel
Moving my body
Starting my engine
Stopped car
*/